#!/usr/bin/env ruby
require 'resolv'
require 'socket'

if(ARGV.size==1 && ARGV[0]=="--get_xml"):
	xml="
		<package>
			<information>
				<name>Portscanner</name>
				<dropdown>Portscan</dropdown>
				<description>This will portscan the given IP address</description>
			</information>
		</package>"

	puts xml
	exit
end

MAX_PORT=1024

output=Time.now.strftime("%b %d %H:%M:%S")+": Port Scanner\n"

#debug - used to check the parameters passed in
#output<<sprintf("arg 0 =%s\n", ARGV[0])
#output<<sprintf("arg 1 =%s\n", ARGV[1])
#output<<sprintf("arg 2 =%s\n", ARGV[2])
if(ARGV.size<2)
	output<<"Not enough parameters passed, third parameter must be the IP address\n"
else
	ip=ARGV[2]

	if (ip =~ /^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/)
		output<<"Scanning "+ip+"\n"
		services = Hash.new
		File.readlines('/karma/etc/services').each do |line|
			next if line[0] == ?# or line =~ /^$/
			name, port = line.match(/(^[a-z][0-9A-Za-z_.+-]*)\s+(\d+)\//).captures
		#    p line if "#{name}" == ''
			services.store(port, name)
		end

		output<<"Port\t    State\tservice\n"

		stime = Time.now
		begin
			for port in 1 .. MAX_PORT
				begin
					s = TCPsocket.open(ip, port)
					x=sprintf("%s/%sopen\t%s\n", port, 'tcp'.ljust(11 - port.to_s.length), services[port.to_s] ? services[port.to_s] : 'unknown')
					output<<x
					s.close
				rescue Errno::ECONNREFUSED
					next
				end
			end
			etime = Time.now()
			output<<sprintf("\nAll %d ports scanned in %.3f seconds\n", MAX_PORT, etime - stime)
		rescue Errno::EHOSTUNREACH
			output<<"IP Unreachable, aborting"
		end
	else
		output<<sprintf("The IP address doesn't look like an IP address (%s), aborting\n",ip)
	end
end
#puts output

log=File.new("/tmp/status.log","a")
log.puts output
log.close
